/*SpUpd!_2018.08.07_0000658*/
/*needVer=2018.08.01_0000657*/

CREATE OR ALTER procedure SP_CONV_DBFTOXML (
    REPN integer)
as
declare variable ID_ILL integer;
declare variable NEW_BED smallint;
declare variable TS smallint;
declare variable MISH smallint;
declare variable KS_RES smallint;
declare variable DS_RES smallint;
declare variable RSLT smallint;
declare variable ID integer;
declare variable NOV smallint;
declare variable MP smallint;
declare variable SPEC smallint;
declare variable VER varchar(10);
begin
for select m.id, sp.code_spec, sp.VERS_SPEC, l.new_bed, iif(m.res_lechen<5,m.res_lechen,iif(m.res_lechen=5,1,4)) mish,
iif(r.tip_stac=1,1,2) TS, i.idrmp_ks, i.idrmp_ds, pb.id_mp --iif(r.oplat=1 and (r.lpu in (57,115,117,127)) and pb.id_mp=136,137,pb.id_mp)
from mtl m
join stacion s on s.id_ill=m.id_ill
join reports r on r.repn=s.repn
join lst_koiki l on l.tip=m.profile and l.datebeg<=s.out_stac and (l.dateend>=s.out_stac or (l.dateend is null))
join profil_bed pb on pb.bed_id=l.new_bed and pb.old_bed=m.profile and pb.datebeg<=s.out_stac and (pb.dateend>=s.out_stac or (pb.dateend is null) )
join ishod_lece i on i.mykey=iif(m.res_lechen=6,9,m.ishod_lece)
left join spr_speciality sp on sp.stac_code = m.vr_spec and (r.date_beg between sp.datebeg and coalesce(sp.dateend, '31.12.9999'))
where r.repn=:repn
into :id, :SPEC, :VER, :new_bed, :mish, :ts, :ks_res, :ds_res, :MP do
begin
if(ts=1) then rslt=ks_res; else rslt=ds_res;
update mtl m set m.rslt=:rslt, m.ishod=( :mish+ :TS*100), m.profil_bed=:new_bed, m.pr_fed=:mp where m.id=:id;
update mtl m set m.prvs=:SPEC, m.VERS_SPEC=:VER where (m.id=:id) and (:SPEC is not null); -- / AMV 26.06.2018 / convert from vr_spec to prvs
end
for select distinct s.id_ill, iif(s.sres_lechen<5,s.sres_lechen,iif(s.sres_lechen=5,1,4)) sish,
iif(r.tip_stac=1,1,2) TS, i.idrmp_ks, i.idrmp_ds, iif(s.novor is null, 1,0) from mtl m
join stacion s on s.id_ill=m.id_ill
join reports r on r.repn=s.repn
join ishod_lece i on i.mykey=iif(s.sres_lechen=6,9,s.sishod_lece)
where r.repn=:repn
into :id_ill, :mish, :ts, :ks_res, :ds_res, :nov do
begin
if(ts=1) then rslt=ks_res; else rslt=ds_res;
update stacion s set s.rslt=:rslt, s.ishod=( :mish+ :TS*100) where s.id_ill=:id_ill;
if (nov=1) then update stacion s set s.novor=0 where s.id_ill=:id_ill;
end
suspend;
end;
@
UPDATE PROFIL_BED SET 
    OLD_BED = 104
WHERE (ID_MP = 137) AND
      (BED_ID = 8) AND
      (OLD_BED = 40) AND
      (DATEEND IS NULL);
@
UPDATE OR INSERT INTO LST_KOIKI (TIP, PROFIL, OMS, NEW_BED, DATEBEG, DATEEND)
VALUES (104, '    ', 26, 8, '2018-04-01 00:00:00', NULL)
MATCHING (TIP);
@
commit work;
@
update MTL M
set M.VID_POM = 13
where M.ID in (select M1.ID
               from MTL M1
               join REPORTS R on R.REPN = M1.REPN
               where R.TIP_STAC in (2, 3) and
                     M.VID_POM = 31 and
                     R.DATE_BEG >= '01.05.2018');
@
commit work;
@